<?php
//%version:14.0.3.9%
$errlog = 0;
$maxerrlines = 50;
if (isset($_SERVER['HTTP_CLIENT_IP'])) {
    $ip = $_SERVER['HTTP_CLIENT_IP'];
} elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
    $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
} else {
    $ip = $_SERVER['REMOTE_ADDR'];
}
$url = $_SERVER ['REQUEST_URI'];

if(!$errlog) {
	$errdate = date ("D d M Y H:i:s", time());
	$newline = $errdate . " | " . str_pad($ip, 14, ' ') . " | " . $url . "\n";
	$errfile = "404_error_log.txt";
	if( !file_exists($errfile) ) {
		$fp = fopen($errfile,"c+");
		flock($fp, LOCK_EX);
		fwrite($fp, $newline);
		flock($fp, LOCK_UN);
		fclose($fp);
	}
	else {
		$fp = fopen($errfile, "r+");
		if($fp) {
			$locked = getLock($fp, LOCK_SH);
			if($locked) {
				flock($fp, LOCK_UN);
				$lines = file( $errfile );
				$locked = getLock($fp, LOCK_EX);

				if($locked && $lines !== false) {

					if( $maxerrlines ) {
						$linecount = sizeof($lines);
						while($linecount >= $maxerrlines) {
							array_pop( $lines );
							$linecount--;
						}
						array_unshift( $lines, $newline );
						$towrite = join('',$lines);

						ftruncate($fp,0);
						fwrite($fp,$towrite);
						fflush($fp);
					}
				}
				flock($fp, LOCK_UN);
			}
			fclose($fp);
		}
	}
}
?>